
	// gestione delle preferenze

var gAppName = 'EUVAT';
var gAppVersion = '0.03';

var gPref = new WidgetPreference(gAppName, gAppVersion,{

	lastState: 0,
	
	lastUpdateCheck: -1

});

// TBD: schedulare con un timer asincrono o inserire il check nelle preferenze

function ChkNV() {

	var d = new Date();

	var lastCheck = gPref.Get('lastUpdateCheck');
	if (d.getTime() - lastCheck > 1000 * 60 * 60 * 24) { // 1 giorno
//	if (d.getTime() - lastCheck > 1000) {
	
		var newVersionData = CheckForNewVersion(gAppName, gAppVersion, gPref.GetUniqueSerial());
		if (newVersionData != 'NONE') {

			var versionAvailable = newVersionData.split('|')[0];
			var versionLink = newVersionData.split('|')[1];
		
			$('newVersion').style.display = 'block';
//			$('widgetDesc').style.display = 'none';
			
			$('newVersionId').innerHTML = versionAvailable;
			$('newVersionLink').onclick = function() { widget.openURL(versionLink); return false; };
		}

		alert('CheckForNewVersion(): Risultato: ' + newVersionData);
	
		gPref.Set('lastUpdateCheck', d.getTime());
	}
}

var updTimer = setInterval('ChkNV()', 60 * 1000);	// 1 minuto dopo l'avvio dell'applicazione
//var updTimer = setInterval('ChkNV()', 5000);	// 10 minuti

	// startup

//var timerInterval = null;

window.onload = OnLoad;

if (window.widget) {

	widget.onhide = OnHide;
	widget.onshow = OnShow;

} else {}

function OnLoad() {

	if (window.widget)
		alert("Start with serial [" + gPref.GetUniqueSerial() + "]!");

	$('widgetVersion').innerHTML = gAppVersion;

	$('MS').selectedIndex = gPref.Get('lastState', 0);

	CheckData();
	StatusMsg('VAT verify, version ' + gAppVersion);

	OnShow();
}

function OnShow() {}
function OnHide() {}

//

function StatusMsg(msg) {

	$('result').innerHTML = msg;
}

function CheckData(event) {

	if (event && event.keyCode == 13 && ! $('submit').disabled) {

		$('submit').onclick();
		
		return;
	}

	var alphabeth = "ABCDEFGHIJKLMNOPQRSTUVWXYZ*+";
	var digits = "0123456789";
	
	var VAT = $('VAT').value;
	
	VAT = VAT.replace(/^\s+/, '');
	VAT = VAT.replace(/\s+$/, '');
	
	var VATvalid = false;
	if (VAT != '') {
	
		VATvalid = true;
		for (i = 0; i < VAT.length; i++) {
		
			if (digits.indexOf(VAT.substr(i, 1)) == -1 &&
				(alphabeth.indexOf(VAT.substr(i, 1).toUpperCase()) == -1)) {
				
				VATvalid = false;
			}
		}
	}

	$('submit').disabled = ($('MS').selectedIndex <= 0 || ! VATvalid);

//alert("Check [" + ($('MS').selectedIndex) + "][" + VAT + "] " + ($('submit').disabled ? 'disabilitato' : 'abilitato'));
}

function OptionChanged() {

	CheckData();
	
	gPref.Set('lastState', $('MS').selectedIndex);
}

var gRequest = null;

function DoVATVerify() {

	StatusMsg('Doing query ...');
	
	if (gRequest !== null)
		alert("gRequest is not null");

	var d = new Date();
	var seed = d.getTime();

//	<input type="hidden" name="Lang" value="EN">
//	select name="MS"
//               <input type="text" size="2" maxlength="2" name="ISO" readonly="readonly" onFocus="setTimeout('document.myform.ISO.blur()',1);" value="---" style ="bottom:auto; background:#FFFFFFF; border: #FFFFFFF">
//               <input type="text" size="20" maxlength="12" name="VAT">

	var countryCode = $('MS').options[ $('MS').selectedIndex ].value;

	var queryPars = [
	
		'Lang=EN',
		'MS=' + countryCode,
		'ISO=' + countryCode,
		'VAT=' + $('VAT').value
	];

	var pars = {
	
		asynchronous: true,
		onComplete: QueryDone,
		method: 'get',
		parameters: queryPars.join('&')
	};

	gRequest = new Ajax.Request('http://europa.eu.int/comm/taxation_customs/vies/cgi-bin/viesquer', pars);
}

function QueryDone(transport) {

//alert("Query done");

if (window.widget)
	alert("Query Done!");

    if (transport.status == 200) {

			var result = ParseResult(transport.responseText);
			DisplayStatus(result);

//    	alert('Risultato: ' + transport.responseText);

    } else {

			var msg = 'Error in loading: ' + transport.status
    	for (v in transport)
				msg += v + ': ' + transport[v] + '\n';

    	alert(msg);
    }

	gRequest = null;
}

var kVATResultValid = 1;
var kVATResultInvalid = 2;
var kVATResultUnknown = 3;

function ParseResult(v) {

/*

    Yes, valid VAT number
    No, invalid VAT number

*/

		// double check result

	var posValid = v.indexOf('Yes, valid VAT number');
	var posInvalid = v.indexOf('No, invalid VAT number');

//	alert("Start: " + posValid);
//	alert("Start: " + posInvalid);

	if (posValid > 0 && posInvalid == -1) {

		return kVATResultValid;

	} else if (posValid == -1 && posInvalid > 0) {

		return kVATResultInvalid;

	} else {

		return kVATResultUnknown;
	}
} 

function DisplayStatus(status) {

	switch (status) {
	
		case kVATResultValid:
						StatusMsg('VAT number is VALID');
						$('result').className = 'resultValid';
					break;
					
		case kVATResultInvalid:
						StatusMsg('VAT number is INVALID');
						$('result').className = 'resultInvalid';
					break;
					
		case kVATResultUnknown:
						StatusMsg('Unknown status.');
						$('result').className = 'resultNone';
					break;
	}
}

function debug(msg) {
	if (!debug.box) {
		debug.box = document.createElement("div");
		debug.box.setAttribute("style", "background-color: white; " +
										"font-family: monospace; " +
										"border: solid black 3px; " +
										"position: absolute;top:10px;" +
										"padding: 10px;" + 
										"color: black;");

		// broken in Tiger 323, document.body is null
		// document.body.appendChild(debug.box);
		document.appendChild(debug.box);
		
		debug.box.innerHTML = "<h1 style='text-align:center'>Debug Output</h1>";
	}
	
	var p = document.createElement("p");
	p.appendChild(document.createTextNode(msg));
	debug.box.appendChild(p);
}

